package classes;

import java.util.ArrayList;

public class CpsEdge {

	float maxCapacity;
	float flow;
	boolean isWorking;
	//State represents the real status of the edge
	//If it breaks --> stay ruin no matter the actual scenario
	//The only way to repair it is through manual change (setStateEdge) 
	
	ArrayList<Integer> tags;

	CpsObject A;
	CpsObject B;

	public CpsEdge(CpsObject A, CpsObject B) {
		setA(A);
		setB(B);
		this.A.AddConnection(this);
		this.B.AddConnection(this);
		this.maxCapacity = 100;
		flow = 0;
		isWorking = true;
	}

	public CpsEdge(CpsObject A, CpsObject B, float maxCap) {
		setA(A);
		setB(B);
		this.A.AddConnection(this);
		this.B.AddConnection(this);
		this.maxCapacity = maxCap;
		flow = 0;
		isWorking = true;
	}

	/**
	 * @return the capacity
	 */
	public float getCapacity() {
		return maxCapacity;
	}

	/**
	 * @param cap
	 *            the Capacity to set
	 */
	public void setCapacity(float cap) {
		this.maxCapacity = cap;
	}

	/**
	 * @return the flow
	 */
	public float getFlow() {
		return flow;
	}

	/**
	 * @param flow
	 *            the flow to set
	 */
	public void setFlow(float flow) {
		this.flow = flow;
		/**
		if (flow <= maxCapacity || flow == -1) {
			isWorking = true;
		} else {
			isWorking = false;
			state = false;
		}
		**/
	}
	
	public void calculateState(boolean simMode){
		if(flow > maxCapacity && maxCapacity != -1){
			isWorking = false;
		}else {
			if(!simMode && flow <= maxCapacity){
				isWorking = true;
			}
		}
	}

	/**
	 * @return the a
	 */
	public CpsObject getA() {
		return A;
	}

	/**
	 * @param a
	 *            the a to set
	 */
	public void setA(CpsObject a) {
		A = a;
	}

	/**
	 * @return the b
	 */
	public CpsObject getB() {
		return B;
	}

	/**
	 * @param b
	 *            the b to set
	 */
	public void setB(CpsObject b) {
		B = b;
	}
	
	public void setState(boolean state){
		isWorking = state;
	}

	public boolean getState() {
		return isWorking;
	}
	
	public void setTags(ArrayList<Integer> tags){
		this.tags = tags;
	}
	
	public ArrayList<Integer> getTags(){
		return tags;
	}
	
	public void addTag(int tag){
		tags.add(tag);
	}

}